/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahlbeteiligung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahlbeteiligung.boundary.AbstractWahlbeteiligungSearchParameters;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungChangeEvent;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungConversationStore;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungExtendedDAO;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungSearch;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahlbeteiligung.entity.Wahlbeteiligung;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlbeteiligungSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlbeteiligungSearchView.VIEW_ID, useCase = UseCasePermission.WAHLBETEILIGUNG_SEARCH)
public abstract class AbstractWahlbeteiligungSearchView extends AbstractElectSearchView<Wahlbeteiligung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungSearchView";
  
  public static final String VIEW_ID = "/wahlbeteiligung/wahlbeteiligung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlbeteiligungSearchView requestHandler;

  @Inject
  private transient WahlbeteiligungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlbeteiligungConversationStore.class)
  protected transient WahlbeteiligungConversationStore conversationStore;

  @Inject
  protected transient WahlbeteiligungSearch search;

  @Inject
  @ConversationGroup(AbstractWahlbeteiligungSearchParameters.class)
  protected transient WahlbeteiligungSearchParameters searchParameters;

  @Inject
  protected transient WahlbeteiligungMeta entityMeta;

  public AbstractWahlbeteiligungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Wahlbeteiligung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Wahlbeteiligung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlbeteiligungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Wahlbeteiligung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Wahlbeteiligung> create();
  }

  @Override
  public List<Wahlbeteiligung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Wahlbeteiligung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlbeteiligungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlbeteiligungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlbeteiligungSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlbeteiligungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlbeteiligungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
